#include <dos.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <mem.h>
#include <math.h>

extern void xinit (void);
extern void scroll (int x,int y);
extern void spriteput (int x,int y,char far *sprite);
extern void spriteget (int x,int y,char far *sfondo,char far *get);
void init (void);
void drw_screen (void);
void prova (void);
void deinit (void);
void error (int i);
void interrupt (*oldint9)(void);
void interrupt newint9(void);

char *blk,*pal;
int acc,vel,velres,rotres;

struct {
 char up,down,left,right,fire;
} dir;

struct {
 char far *sprite,*get_sfondo,*sfondo;
} car[64];

struct {
 int x,y;
} spost[64][16*3];

struct {
 int velocita,rotazione;
} conv[16*6][16*6];



main()
{
 init();
 drw_screen();
 prova();
 deinit();
 return 0;
}



void init(void)
{
 FILE *pf;
 int size[128],i,rot,vel,x,y;

 blk=malloc(203);
 pf=fopen("prova.spr","rb");
 fread(blk,203,1,pf);
 fclose(pf);

 pf=fopen("car.spr","rb");
 fread(&i,2,1,pf);
 fread(size,256,1,pf);
 for(i=0;i<64;i++)
 {
  printf("%d: %d %d\n",i,size[i*2],size[i*2+1]);
  car[i].sprite=farmalloc(size[i*2]);
  if(car[i].sprite==NULL) error(0);
  fread(car[i].sprite,size[i*2],1,pf);
  car[i].sfondo=farmalloc(size[i*2]);
  if(car[i].sfondo==NULL) error(0);
  _fmemcpy(car[i].sfondo,car[i].sprite,size[i*2]);
  car[i].get_sfondo=farmalloc(size[i*2+1]);
  if(car[i].get_sfondo==NULL) error(0);
  fread(car[i].get_sfondo,size[i*2+1],1,pf);
 }
 fclose(pf);

 for(rot=0;rot<64;rot++)
 {
  for(vel=0;vel<0X30;vel++)		// 3.0
  {
   spost[rot][vel].x=cos(rot*M_PI/32+M_PI_2)*vel;
   spost[rot][vel].y=-sin(rot*M_PI/32+M_PI_2)*vel;
  }
 }

 for(x=-0X2F;x<0X30;x++)
 {
  for(y=-0X2F;y<0X30;y++)
  {
   conv[x+0X30][y+0X30].velocita=sqrt(x*x+y*y);
   if(x!=0)
   {
    if(x>0 && y>=0) conv[x+0X30][y+0X30].rotazione=48-atan((float)y/(float)x)*16/M_PI_2;
    else
    {
     if(x>0 && y<0) conv[x+0X30][y+0X30].rotazione=48+atan(-(float)y/(float)x)*16/M_PI_2;
     else
     {
      if(x<0 && y>=0) conv[x+0X30][y+0X30].rotazione=16+atan(-(float)y/(float)x)*16/M_PI_2;
      else conv[x+0X30][y+0X30].rotazione=16-atan((float)y/(float)x)*16/M_PI_2;
     }
    }
   }
   else
   if(y>=0) conv[x+0X30][y+0X30].rotazione=32;
   else conv[x+0X30][y+0X30].rotazione=0;
  }
 }
 oldint9=getvect(9);
 setvect(9,newint9);

 xinit();

 pal=malloc(768);
 pf=fopen("car.pal","rb");
 fread(pal,768,1,pf);
 fclose(pf);
 for(i=0;i<768;i+=3)
 {
  outportb(0X3C8,i/3);
  outportb(0X3C9,(*(pal+i))>>2);
  outportb(0X3C9,(*(pal+i+1))>>2);
  outportb(0X3C9,(*(pal+i+2))>>2);
 }
 free(pal);
}



void drw_screen(void)
{
 FILE *pf;
 int x,y;
 char c;

 pf=fopen("lev1.dat","rb");
 for(y=39;y>=0;y--)
 {
  for(x=0;x<100;x++)
  {
   c=fgetc(pf);
   if (c!=0) spriteput(x*8,y*8,blk);
  }
 }
 fclose(pf);
}



void prova(void)
{
 unsigned int x=0,y=0,x1,y1,xs=0,ys=0,xs1,ys1,rot,rot1,tmp;
 char controt,contacc,contatt,att,fren,contfren,contatt2,att2;

 acc=1;
 att=4;
 fren=2;
 att2=2;
 vel=0;
 rot=0;
 controt=0;
 contatt=0;
 contacc=0;
 contfren=0;
 contatt2=0;
 spriteget(x,y,car[rot].sfondo,car[rot].get_sfondo);
 spriteput(x,y,car[rot].sprite);
 while(!dir.fire)
 {
  if(dir.up) contacc++;
  else contatt++;
  if(dir.down) contfren++;
  if(contacc==acc)
  {
   contacc=0;
   vel++;
  }
  if(contatt==att)
  {
   contatt=0;
   vel--;
  }
  if(contfren==fren)
  {
   contfren=0;
   vel--;
  }
  if(vel>=0X30) vel=0X2F;
  if(vel<0) vel=0;
  contatt2++;
  if(contatt2==att2)
  {
   contatt2=0;
   velres--;
  }
  if(velres<0) velres=0;
  if(dir.left || dir.right) controt++;
  if(controt==2)
  {
   rot1=(rot+dir.left-dir.right)&0X3F;
   tmp=conv[spost[rotres][velres].x+(spost[rot][vel].x>>1)+0X30][spost[rotres][velres].y+(spost[rot][vel].y>>1)+0X30].velocita;
   rotres=conv[spost[rotres][velres].x+(spost[rot][vel].x>>1)+0X30][spost[rotres][velres].y+(spost[rot][vel].y>>1)+0X30].rotazione;
   velres=tmp;
   if(velres>=0X30) velres=0X2F;
   //vel-=vel>>4;
   controt=0;
  }
  else rot1=rot;
  x1=x+spost[rot][vel].x; //+spost[rotres][velres].x;
  y1=y+spost[rot][vel].y; //+spost[rotres][velres].y;
  if(x1>0X3200) x1=x;		//800
  if(y1>0X1400) y1=y;           //320
  if(x1!=x || y1!=y || rot1!=rot)
  {
   while(!(inportb(0X03DA)&0X08));
   while(inportb(0X03DA)&0X08);
   spriteput(x>>4,y>>4,car[rot].sfondo);
   spriteget(x1>>4,y1>>4,car[rot1].sfondo,car[rot1].get_sfondo);
   spriteput(x1>>4,y1>>4,car[rot1].sprite);
   xs1=(x1>>4)-152;
   ys1=(y1>>4)-88;
   if(xs1>480) xs1=xs;
   if(ys1>120) ys1=ys;
   if(xs1!=xs || ys1!=ys)
   {
    scroll(xs1,ys1);
    xs=xs1;
    ys=ys1;
   }
   x=x1;
   y=y1;
   rot=rot1;
  }
 }
}



void deinit(void)
{
 union REGS r;
 int i;

 r.x.ax=0X0003;
 int86(0X10,&r,&r);
 setvect(9,oldint9);
 free(blk);

 for(i=0;i<64;i++)
 {
  farfree(car[i].sprite);
  farfree(car[i].sfondo);
  farfree(car[i].get_sfondo);
 }
}



void error(int i)
{
 deinit();
 switch(i)
 {
  case 0:printf("OUT OF MEMORY\n");break;
 }
 exit(1);
}



void interrupt newint9(void)
{
 char c;

 c=inportb(0X60);
 switch(c)
 {
  case 0X17:dir.up=1;break;
  case 0X97:dir.up=0;break;
  case 0X25:dir.down=1;break;
  case 0XA5:dir.down=0;break;
  case 0X24:dir.left=1;break;
  case 0XA4:dir.left=0;break;
  case 0X26:dir.right=1;break;
  case 0XA6:dir.right=0;break;
  case 0X22:dir.fire=1;break;
  case 0XA2:dir.fire=0;break;
 }
 outportb(0X20,0X20);
}